// -----------------------------------------------------------
// -----------------------------------------------------------
#include "stdafx.h"
#include "whooperX.h"
// -----------------------------------------------------------
// -----------------------------------------------------------
#include "xlcall.h"
#include "framewrk.h"
// -----------------------------------------------------------
// -----------------------------------------------------------

BEGIN_MESSAGE_MAP(CxllApp, CWinApp)

END_MESSAGE_MAP()


CxllApp::CxllApp()
{

}

CxllApp theApp;

// -----------------------------------------------------------
// -----------------------------------------------------------
// -----------------------------------------------------------
// -----------------------------------------------------------
// -----------------------------------------------------------
// -----------------------------------------------------------

int err;
char buf[8192];
char txt[8192];
int nFuncs;   
extern void AutomationSetup();  // Remove this if you don't need automation in the xll
extern void AutomationTerminate();  // Remove this if you don't need automation in the xll
extern void Auto_Open();

// -----------------------------------------------------------
// -----------------------------------------------------------
// Function registering Table 
// See http://www.whooper.co.uk/excelsdkbook.htm for more details
// These arguments are passed to the Excel Register function on opening the xll
// the arguments: procedure name in code, type text, function name in excel, arg, macro type, function wizard category, shortcut_text, help topic, function wizard function help, function wizard argument help, ...
// Don't forget to maintain this list of functions in the whooperX.def file as well

static LPSTR func[][14] = {
{"ThisCell"      , "R#"  , "whooperX_ThisCell"        , ""                               , "1", "whooperX", "", "", "Returns the contents of calling cell"    , "", "", "", "", ""},
{"NowNonVolatile", "RP"  , "whooperX_NowNonVolatile"  , "Dummy"                          , "1", "whooperX", "", "", "Non volatile NOW()"                      , "This dummy dependency argument is unused inside the funtion", "", "", "", ""},
{"Lookup2d"      , "RRRR", "whooperX_Lookup2d"        , "Range, Row Value, Column Value" , "1", "whooperX", "", "", "2D exact match lookup"                   , "", "", "", "", ""},
{"CommandMacro"  , "JJ"  , "whooperX_CommandMacro"    , ""                               , "2", "whooperX", "", "", ""                                        , "", "", "", "", ""},
{"Junky"         , "JB"  , "whooperX_Junky"           , ""                               , "2", "whooperX", "", "", ""                                        , "", "", "", "", ""},
{"CommandMacroOle", ""    , "whooperX_CommandMacroOle" , ""                               , "2", "whooperX", "", "", ""                                        , "", "", "", "", ""},
{"Junk1"         , "BBB" , "whooperX_Junk1"           , "Arg 1, Arg 2"                   , "1", "whooperX", "", "", "Returns the sum of the numbers"          , "Help on Arg 1", "Help on Arg 2", "", "", ""},
{"Junk2"         , "EPP" , "whooperX_Junk2"           , "Arg 1, Arg 2"                   , "1", "whooperX", "", "", "Returns the product of the numbers"      , "", "", "", "", ""},
{"Junk3"         , "JP"  , "whooperX_Junk3"           , "Dummy"                          , "1", "whooperX", "", "", "Returns count of number of times called" , "", "", "", "", ""},
{0,0,0,0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
  };

// -----------------------------------------------------------
// -----------------------------------------------------------
// xlAutoOpen

BOOL __stdcall xlAutoOpen(void) {
 AFX_MANAGE_STATE(AfxGetStaticModuleState( ));

 //int i;

 // Get XLL file name
 static XLOPER xDll;
 Excel(xlGetName, &xDll, 0);

 // Loop through the function list, and register the functions
 for(nFuncs=0; func[nFuncs][0]; nFuncs++) {
	
	 // Setup the arguments as strings with a character count in first byte
	 LPSTR args[14];
	 for (int k=0; k<14; k++)
	 {
		 int len=strlen(func[nFuncs][k]);
		 args[k]=new char[ len+2 ];
		 args[k][0]=(BYTE) len;
		 strcpy(args[k]+1,func[nFuncs][k]);
	 }

    // Register a function
    err = Excel(xlfRegister, 0, 14, (LPXLOPER)&xDll,
       (LPXLOPER)TempStr(args[0]),
       (LPXLOPER)TempStr(args[1]),
       (LPXLOPER)TempStr(args[2]),
       (LPXLOPER)TempStr(args[3]),
       (LPXLOPER)TempStr(args[4]),
       (LPXLOPER)TempStr(args[5]),
       (LPXLOPER)TempStr(args[6]),
       (LPXLOPER)TempStr(args[7]),
       (LPXLOPER)TempStr(args[8]),
       (LPXLOPER)TempStr(args[9]),
       (LPXLOPER)TempStr(args[10]),
       (LPXLOPER)TempStr(args[11]),
       (LPXLOPER)TempStr(args[12]),
       (LPXLOPER)TempStr(args[13])
       );

    if(err != xlretSuccess) {
     sprintf(buf, "xlfRegister for function %d, err = %d", nFuncs, err);
     AfxMessageBox(buf, MB_SETFOREGROUND);
    }

	for (int k=0; k<14; k++)
	 {
		 delete args[k];
	 }
 }

 Excel(xlFree, 0, 1, (LPXLOPER)&xDll);


 // Set up OLE Automation 
 AutomationSetup();   // Remove this if you don't need automation in the xll

 Auto_Open(); // See functions.cpp module

 return 1;
}

// -----------------------------------------------------------
// -----------------------------------------------------------
// xlAutoClose

BOOL __stdcall xlAutoClose(void) {

 return 1;
}


// -----------------------------------------------------------
// -----------------------------------------------------------
// xlAddInManagerInfo

// Gives descriptive information about the add-in under Tools, Addins
LPXLOPER _stdcall xlAddInManagerInfo(LPXLOPER xAction) {
 static XLOPER xInfo, xIntAction;

 Excel(xlCoerce, &xIntAction, 2, xAction, TempInt(xltypeInt));

 if(xIntAction.val.w == 1) {
     xInfo.xltype = xltypeStr;
	 // Addin Name in next statement...
     xInfo.val.str = (PUCHAR) " whooperX.xll";
     xInfo.val.str[0] = (UCHAR) strlen( (char*) &xInfo.val.str[1]);
 }
 else {
     xInfo.xltype = xltypeErr;
     xInfo.val.err = xlerrValue;
 }

 return (LPXLOPER)&xInfo;
}

// -----------------------------------------------------------
// -----------------------------------------------------------
